/*  fortune-udp - A RFC865 compliant client.
    Copyright (C) 2000 Afghan Hound Software

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/

/* udpclient.c - gets qotdd from rfc865 server */

#include "main.h"


int main(int argc, char **argv)
{
  char *host;
  int  port,ret,len,login;
  struct in_addr *host_addr;
  char qotd[ABS_MAX];
  int sock;
  struct sockaddr_in their_addr;
  struct sockaddr_in my_addr;

  login = parse_client_option(argc,argv,"udp");

  host=(char *)xmalloc(100*sizeof(char));
  host_addr = (struct in_addr *)xmalloc(sizeof(struct in_addr));

  host=get_host(host);
  port=get_port("udp");
  if ((host_addr=atoaddr(host))==NULL){
    printf("fortune.udp: Bad host name, exiting.\n");
    exit(1);
  }

  if ((sock = socket(AF_INET, SOCK_DGRAM, 0)) == -1){
    perror("socket");
    exit(1);
  }

  memset((char *) &their_addr,0,sizeof(their_addr));
  memset((char *) &my_addr,0,sizeof(my_addr));

  their_addr.sin_family   = AF_INET;    
  their_addr.sin_port     = port;   
  their_addr.sin_addr     = *((struct in_addr *)host_addr);
  my_addr.sin_family      = AF_INET;    
  my_addr.sin_port        = htonl(INADDR_ANY);   
  my_addr.sin_addr.s_addr = htons(0);
  
  if (bind(sock, (struct sockaddr *) &my_addr, sizeof(my_addr)) < 0) {
    perror("bind");
    exit(1);
  }

  if ((ret=sendto(sock,(char *)&ret,1,0,(struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1) {
    perror("sendto");
    exit(1);
  }

  len = sizeof(my_addr);
  if ((ret=recvfrom(sock,qotd,ABS_MAX,0,(struct sockaddr *)&my_addr,&len)) == -1) {
    perror("recv");
    exit(1);
  }
  close(sock);
  qotd[ret] = '\0';
  
  if (login){printf("\n");}
  printf("%s",qotd);
  if (login){printf("\n");}
  if (wait_flag)
    {
      sleep( (int) (0.05761*strlen(qotd)));
    }
  return 0;
}
