/*  aqotdd - Afghan's Quote of the day server - An RFC865 compliant server.
    fortune-tcp,fortune-udp,udpbench,tcpbench - RFC865 compliant clients

    Copyright (C) 2000 Afghan Hound Software

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/

/* network.c - Opens, reads and writes to the network. */

#include "main.h"




void net_tcp_con();
void net_setsocknonblock(int sck);
void net_udp_con();
int net_check(struct sockaddr_in who,int type);
int  net_getidentinfoz(struct in_addr target,int remoteport,char *owner);
void net_logconnection(struct sockaddr_in who,int type);
void net_tcp_init();
void net_udp_init();
int  net_add_next(char *next,struct in_addr **ips,struct in_addr **net,int num);
int  net_sort_next_bit(char *bit,int *errorflag);
int  net_check_list(struct in_addr who,struct in_addr **ips,struct in_addr **net,int num);
struct in_addr *ip_addrs_deny;
struct in_addr *ip_addrs_allow;
struct in_addr *netmasks_allow;
struct in_addr *netmasks_deny;
int                n_allow   = 0;
int                n_deny    = 0;


int net_sort_next_bit(char *bit,int *errorflag)
{
  int temp;
  temp = atol(bit);
  if ((temp>-1)&&(temp<256)){return temp;}
  errorflag[0] = 1;
  return 0;
}

int net_add_next(char *next,struct in_addr **ips,struct in_addr **msk,int num)
{
  int   flag    = 0;
  int   errflag = 0;
  char *copy;
  char *bit;
  int   numbits = 0;
  int   bits[8];
  int   i,t;
  unsigned long int j,k,l;
  char  buf1[20];
  char  buf2[20];

  /* Drunk - Must check what netmasks mean (here) - is 255    */
  /* or 0 the default?                                        */
  /* Apart from that - *should* set bits[0-3] to ip, bits[4-7]*/
  /* to netmask - if net_check_lists is working as well, this */  
  /* is all cool!                                             */
  /* ip/16 <-> ip/255.255.0.0 - in theory. I'll have to check */
  /* before I can update the man page....*eeek!*              */
  /* The Following Morning....*think* it's doing the right    */
  /* thing(tm) now...                                         */
  
  memset(&buf1,0,20);
  memset(&buf2,0,20);
  bits[0]=0;bits[1]=0;bits[2]=0;bits[3]=0;
  bits[4]=0;bits[5]=0;bits[6]=0;bits[7]=0;
  if (!strcmp(next,"all"))
    {
      flag = 1;
      bits[0]=0  ;bits[1]=0  ;bits[2]=0  ;bits[3]=0;
      bits[4]=0  ;bits[5]=0  ;bits[6]=0  ;bits[7]=0;
    }
  if (!flag)
    {
      copy = (char *)xmalloc((strlen(next)+1)*sizeof(char));
      strcpy (copy,next);
      bits[0]=255;bits[1]=255;bits[2]=255;bits[3]=255;
      bit = strtok(copy,"/."); /* /. Yeah! */
      while ((bit!=NULL)&&(numbits<8))
	{
	  bits[numbits] = net_sort_next_bit(bit,&errflag);
	  numbits++;
	  bit = strtok(NULL,"/.");
	}
      if (copy!=NULL){free(copy);}
      if ((errflag)||(numbits==0)){return num;}
      if (numbits<5) /* xx, xx.xx, xx.xx.xx, xx.xx.xx.xx */
	{  
	  bits[4]=0;bits[5]=0;bits[6]=0;bits[7]=0;
	  for (i=0;i<numbits;i++){bits[4+i]=255;}
	  for (i=numbits;i<4;i++){bits[i]=0;}
	  flag = 1;
	}
      
      if ((numbits==5)&&(bits[4]>=0)&&(bits[4]<=32)) /* xx.xx.xx.xx/yy */
	{
	  j=0;k=128;l=4;t=bits[4];bits[4] = 0;
	  for (i=0;i<t;i++)
	    {
	      j+=k;k/=2;
	      if ((i==7)||(i==15)||(i==23))
		{
		  bits[l]=j;l++;j=0;k=128;
		}
	    }
	  bits[l]=j;
	  flag=1;
	}
      if (numbits==8)  /*xx.xx.xx.xx/yy.yy.yy.yy */
	{
	  flag = 1;
	}
    }
  sprintf(buf1,"%d.%d.%d.%d",bits[0],bits[1],bits[2],bits[3]);
  sprintf(buf2,"%d.%d.%d.%d",bits[4],bits[5],bits[6],bits[7]);
  if (flag)
    {
      num++;
      ips[0] = (struct in_addr *)xrealloc(ips[0],(sizeof(struct in_addr)*(num)));
      msk[0] = (struct in_addr *)xrealloc(msk[0],(sizeof(struct in_addr)*(num)));
#ifdef HAVE_INET_ATON      
      inet_aton(buf1,&ips[0][(num-1)]);
      inet_aton(buf2,&msk[0][(num-1)]);
#else
      ips[0][(num-1)] = inet_makeaddr(inet_addr(buf1),inet_addr(buf1));
      msk[0][(num-1)] = inet_makeaddr(inet_addr(buf2),inet_addr(buf2));
#endif /* HAVE_INET_ATON */      
    }
  return num;
}

void net_build_control_lists()
{
  int  i;
  char *l_allow,*l_deny,*next,**list;
  if (n_deny) {free(ip_addrs_deny); free(netmasks_deny);}
  if (n_allow){free(ip_addrs_allow);free(netmasks_allow);}
  n_deny = 0;
  n_allow= 0;
  ip_addrs_deny  = NULL;ip_addrs_allow = NULL;
  netmasks_allow = NULL;netmasks_deny  = NULL;
  l_allow = (char *)xmalloc((strlen(allow)+1)*sizeof(char));
  l_deny  = (char *)xmalloc((strlen(deny)+1) *sizeof(char)); 
  strcpy (l_allow,allow);
  strcpy (l_deny, deny); 

  next = strtok(l_allow,",");
  i = 0;list = NULL;
  while (next!=NULL)
    {
      list=(char **)xrealloc(list,(sizeof(char *)*(i+1)));
      list[i] = (char *)xmalloc((strlen(next)+1)*sizeof(char));
      strcpy(list[i],next);
      i++;
      next = strtok(NULL,",");
    }
  for (;i>=1;i--)
    {
      n_allow = net_add_next(list[(i-1)],&ip_addrs_allow,&netmasks_allow,n_allow);
      free(list[(i-1)]);
    }
  free(list);
  
  next = strtok(l_deny,",");
  i = 0;list = NULL;
  while (next!=NULL)
    {
      list=(char **)xrealloc(list,(sizeof(char *)*(i+1)));
      list[i] = (char *)xmalloc((strlen(next)+1)*sizeof(char));
      strcpy(list[i],next);
      i++;
      next = strtok(NULL,",");
    }
  for (;i>=1;i--)
    {
      n_deny = net_add_next(list[(i-1)],&ip_addrs_deny,&netmasks_deny,n_deny);
      free(list[(i-1)]);
    }
  free(list);
  if (l_allow!=NULL){free(l_allow);}
  if (l_deny!=NULL) {free(l_deny);}
}

/* Function blatantly ripped and then hacked from nmap (nmap.c):
    - Note that the sprintf is my fault, the original had a snprinf.
   From the man page:

    nmap - Network exploration tool and security scanner

    <snip>

   The   newest   version   of  nmap  can  be  obtained  from
   http://www.insecure.org/nmap

   nmap is (C) 1997,1998,1999 by Fyodor (fyodor@dhp.com, fyo-
   dor@insecure.org)

   <snip - none of libpcap is here>

   This program is free software;  you  can  redistribute  it
   and/or modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; Ver-
   sion  2.   If  you  want to license nmap under terms other
   than the GPL, you can write Fyodor and  plead  your  case,
   but  none of the (2-3) attempts at this have been success-
   ful.
*/

/* returns 0 for possibly temporary error, -1 means we shouldn't attempt
   inetd again on this host */

int net_getidentinfoz(struct in_addr target, int remoteport,char *owner) 
{
#define SIZEOF_REQUEST 16
  int sd;
  struct sockaddr_in sock;
  int res;
  char request[(SIZEOF_REQUEST+1)];
  char response[1024];
  char *p,*q;
  char  *os;

  if ((sd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1)
    {
      return 0;
    }
  memset((char *)&sock,0,sizeof(sock));
  sock.sin_family = AF_INET;
  sock.sin_addr.s_addr = target.s_addr;
  sock.sin_port = htons(atoport("auth","tcp",DEF_IDENT_PORT));

  /*  usleep(50000);   * If we aren't careful, we really MIGHT take out inetd,
  		      some are very fragile */
  res = connect(sd, (struct sockaddr *) &sock, sizeof(struct sockaddr_in));
  
  if (res < 0 ) 
    {
      close(sd);
      return 0;
    }
  memset((char *)request,0,SIZEOF_REQUEST);
  memset((char *)response,0,1024);
      
  sprintf(request, "%hu, %hu\r\n", remoteport, real_tcp_port);

  if (write(sd, request, strlen(request) + 1) == -1) 
    {
      close(sd);
      return 0;
    }
  else if ((res = read(sd, response, 1024)) == -1) 
    {
      close(sd);
      return 0;
    }
  else 
    {
      close(sd);
      if ((p = strchr(response, ':'))) 
	{
	  p++;
	  if ((q = strtok(p, " :"))) 
	    {
	      if (!strcasecmp( q, "error")) 
		{
		  return 0;
		}
	      if ((os = strtok(NULL, " :"))) 
		{
		  if ((p = strtok(NULL, " :"))) 
		    {
		      if ((q = strchr(p, '\r'))) *q = '\0';
		      if ((q = strchr(p, '\n'))) *q = '\0';
		      strncpy(owner, p, 512);
		    }
		}
	    }
	}
    }
return 1;
}

/* Depends on log_con 1: IP address, 2:IP/hostname, 3:IP/hostname/ident */
void net_logconnection(struct sockaddr_in who,int type)
{
  struct hostent *them;
  char           *ip;
  char           *buf;
  char            name[12];

  buf = NULL;  
  if (log_con)
    {
      if (type==TYPE_UDP)
	{
          strcpy(name,"UDP");
	}
      else 
	{
	  if (type==TYPE_TCP)
	    {
	      strcpy(name,"TCP");
	    }
	  else
	    {
	      if (type==TYPE_DENY_UDP)
		{
		  strcpy(name,"UDP-DENIED");
		}
	      else
		{
		  strcpy(name,"TCP-DENIED");
		}
	    }
	}

      ip = inet_ntoa(who.sin_addr); /*Static buffer - I've checked :) */
      if ((log_con==1)||(type==TYPE_DENY_TCP)||(type==TYPE_DENY_UDP))
	{
	  log_message(LOG_INFO,"%s Connection from %s.\n",&name,ip);
	  return;
	}
      if (log_con>=2)
	{
	  them = gethostbyaddr((char *)&(who.sin_addr),sizeof(struct in_addr),AF_INET); 
	  if ((log_con==2)||((log_con>2)&&(type==TYPE_UDP)))
	    { 
	      log_message(LOG_INFO,"%s Connection from %s (%s).\n",&name,ip,them->h_name);
	    }
	  if ((log_con>2)&&(type==TYPE_TCP))
	    {
	      buf = (char *)xmalloc(513*(sizeof(char)));
	      if(net_getidentinfoz(who.sin_addr,ntohs(who.sin_port),buf))
		{
		  log_message(LOG_INFO,"%s Connection from %s (%s). %s\n",&name,ip,them->h_name,buf);
		  if(buf!=NULL)
		    {
		      free(buf);
		    }
		}
	      else
		{
		  log_message(LOG_INFO,"%s Connection from %s (%s). IDENT ERROR\n",&name,ip,them->h_name);
		  if(buf!=NULL)
		    {
		      free(buf);
		    }
		}
	    }
	}
    }
}

int net_check(struct sockaddr_in who,int type)
{
  int i;
  if (!(order))
    {
      i = 1;
      i -= net_check_list(who.sin_addr,&ip_addrs_deny,&netmasks_deny,n_deny);
      i += net_check_list(who.sin_addr,&ip_addrs_allow,&netmasks_allow,n_allow);
    }
  else
    {
      i = 0;
      i += net_check_list(who.sin_addr,&ip_addrs_allow,&netmasks_allow,n_allow);
      i -= net_check_list(who.sin_addr,&ip_addrs_deny,&netmasks_deny,n_deny);
    }	
  i = !(i<1);
  if (!(i))
    {
      net_logconnection(who,type);
    }
  return i;
}

int  net_check_list(struct in_addr who,struct in_addr **ips,struct in_addr **net,int num)
{
  int i,flag = 0;
  unsigned long int which,target,mask;
  which = inet_lnaof(who);
  for (i=0;i<num;i++)
    {
    
      target = inet_lnaof(ips[0][i]);
      mask   = inet_lnaof(net[0][i]);
      flag = (flag) || ( ((which)&(mask)) == ((target)&(mask)) );
    }    
  return flag;
}

void net_setsocknonblock(int sck)
{
  int options;
  
  options = fcntl(sck,F_GETFL);
  if (options < 0)
    {
      my_message(MSG_ERRFAIL,"Error getting socket options",strerror(errno));
    }
  options = (options | O_NONBLOCK);
  if (fcntl(sck,F_SETFL,options) < 0)
    {
      my_message(MSG_ERRFAIL,"Error setting socket options",strerror(errno));
    }
}

void net_tcp_init()
{
  struct sockaddr_in me;    /* my address information */
  int reuse = 1;

  if ((listen_fd_tcp = socket(AF_INET, SOCK_STREAM, 0)) == -1) 
    {
      my_message(MSG_ERRFAIL,"TCP Socket Error",strerror(errno));
    }
  real_tcp_port = atoport(tcp_port,"tcp",QOTD_DEFPORT);
  setsockopt(listen_fd_tcp,SOL_SOCKET, SO_REUSEADDR,(char *)&reuse,sizeof(reuse));
  net_setsocknonblock(listen_fd_tcp);

  memset((char *)&me,0,sizeof(me));
  me.sin_family      = AF_INET;        
  me.sin_port        = htons(real_tcp_port);    
  me.sin_addr.s_addr = htons(INADDR_ANY); /* *sigh* */

  if (bind(listen_fd_tcp, (struct sockaddr *)&me, sizeof(struct sockaddr))  == -1)
    {
      my_message(MSG_ERRFAIL,"TCP Bind Error",strerror(errno));
    }
  if (listen(listen_fd_tcp, BACKLOG) == -1)
    {
      my_message(MSG_ERRFAIL,"TCP Listen Error",strerror(errno));
    }
}

void net_udp_init()
{
  struct sockaddr_in me;  
  int reuse = 1;

  if ((listen_fd_udp = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
    {
      my_message(MSG_ERRFAIL,"UDP Socket Error",strerror(errno));
    }
  real_udp_port = atoport(udp_port,"udp",QOTD_DEFPORT);
  setsockopt(listen_fd_udp,SOL_SOCKET, SO_REUSEADDR,(char *)&reuse,sizeof(reuse));
  net_setsocknonblock(listen_fd_udp);

  memset((char *)&me,0,sizeof(me));
  me.sin_family      = AF_INET;        
  me.sin_port        = htons(real_udp_port);    
  me.sin_addr.s_addr = htons(INADDR_ANY); /* *sigh* 0 = 0, no?*/      
  
  if (bind(listen_fd_udp, (struct sockaddr *)&me, sizeof(struct sockaddr))  == -1)
    {
      my_message(MSG_ERRFAIL,"UDP Bind Error",strerror(errno));
    }  
}

void net_tcp_con()
{
  int   con_sck,ret,size;
  char *qotd = NULL;
  struct sockaddr_in their_addr;
  
  size = sizeof(struct sockaddr_in);
  if (tcp_connects > max_con_tcp)
    {
      return;
    }
  con_sck = accept(listen_fd_tcp,(struct sockaddr *)&their_addr, &size);
  if ((chk_con)&&(!net_check(their_addr,TYPE_DENY_TCP)))
    {
      close(con_sck);
      return;
    }
  tcp_connects ++;
  if (con_sck < 0)
    {
      return;
    } /* Might be a network problem, not ours. Who cares? */
  qotd = qotd_getquote(qotd);
  ret = send(con_sck,qotd,strlen(qotd),0);
  if (ret < 0)
    {
      my_message(MSG_ERRCONT,"TCP send error",strerror(errno));
    }

  if(log_count)
    {
      tcp_count ++;
    }
  if (log_con) 
    {
      net_logconnection(their_addr,TYPE_TCP);
    }
  free(qotd);
  close(con_sck);
}

void net_udp_con()
{
  struct sockaddr_in client;
  int    ret;
  int    size;
  char   dummy[1];
  char   *qotd;

  if (udp_connects > max_con_udp){return;}
  udp_connects++;
  
  size = sizeof(client);
  /* Need to get at least one byte to get their address */
  ret  = recvfrom(listen_fd_udp,dummy,1,0,(struct sockaddr *) &client, &size);
  if ((chk_con)&&(!net_check(client,TYPE_DENY_UDP)))
    {
      return;
    }
  if (ret < 0)
    {
      return;
    }
  qotd = NULL;
  qotd = qotd_getquote(qotd);
  ret  = sendto(listen_fd_udp,qotd,strlen(qotd),0,(struct sockaddr *)&client,size);
  if (ret < 0)
    {
      my_message(MSG_ERRCONT,"UDP send error",strerror(errno));
    }
  if (log_count)
    {
      udp_count ++;
    }
  if (log_con)
    {
      net_logconnection(client,TYPE_UDP);
    }
  free(qotd);
}

void net_read_sock()
{
  if (real_tcp)
    {
      if (FD_ISSET(listen_fd_tcp,&sockets)){net_tcp_con();}
    }
  if (real_udp)
    {
      if (FD_ISSET(listen_fd_udp,&sockets)){net_udp_con();}
    }
}

void net_init()
{
  my_message(MSG_INITSTART,"Starting network","");
  real_tcp = use_tcp; /* Lock these so they can't go */
  real_udp = use_udp; /* away if the config file says so. */
  if (real_tcp)
    {
      net_tcp_init();
    }
  if (real_udp)
    {
      net_udp_init();
    }
  highsocket = listen_fd_tcp;
  if (real_udp)
    {
      highsocket = listen_fd_udp;
    }
  my_message(MSG_INITFINISH,"Network started","");
}

